#!/usr/bin/env python

#

import os
import sys

XMODMAP_FILE = '/etc/X11/Xmodmap'
TEMP_FILE = 'Xmodmap.tmp'

def restart(data=None):
	if not data:
		print 'argument is failed'
		sys.exit(1)
	if type(data) != type([]):
		print 'data is not list type'
		sys.exit(1)

	setkeycodes()
	ModmapManager(data)
	xmodmap()
	
	sys.exit(1)

def setkeycodes():
	print 'setkeycodes run...'

	command1 = "setkeycodes 71 122"
	command2 = "setkeycodes 72 123"

	os.system(command1)
	os.system(command2)

def xmodmap():
	print 'xmodmap run...'
	
	command = '/usr/X11R6/bin/xmodmap ' + XMODMAP_FILE
	os.system(command)


class ModmapManager:
	def write_xmodmap(self, data=None):
		if (not data) or (type(data) != type([])):
			print 'argument is failed'
			sys.exit(1)

		#fw = open(TEMP_FILE, 'w')
		fw = open(TEMP_FILE, 'a')
		#fw.write('! This file generate xmodmap file\n\n')
		fw.write('keycode %s=Hangul\n' % data[0])
		fw.write('keycode %s=Hangul_Hanja\n' % data[1])
		fw.close()

	def apply(self):
		os.remove(XMODMAP_FILE)

		fo = open(TEMP_FILE, 'r')
		fw = open(XMODMAP_FILE, 'w')
		
		for line in fo.read():
			fw.write(line)

		fw.close()
		fo.close()

		os.remove(TEMP_FILE)

	def open_xmodmap(self):
		fo = open(XMODMAP_FILE, 'r')
		fw = open(TEMP_FILE, 'w')

		for line in fo.readlines():
			if line[0] == '!':
				fw.write(line)
			elif line[0] == '\n':
				fw.write(line)
			else:
				tmp_line = line.split('=')[1].split('\n')[0]
				if tmp_line == 'Hangul' or tmp_line == 'Hangul_Hanja':
					#print line, '<<<<< remove'
					continue
				else:
					fw.write(line)

		fw.close()
		fo.close()


	def __init__(self, data=None):
		print 'Modmap Manager constructor...'
		self.open_xmodmap()
		self.write_xmodmap(data)
		self.apply()

